<template>
  <v-checkbox
    v-model="model"
    :label="label"
    :color="color"
    :error="error"
    :rules="rules"
    hide-details="auto"
    :disabled="disabled"
    :indeterminate="indeterminate"
    @update:model-value="update"
  />
</template>

<script setup>
import { ref, watch, onMounted } from "vue";

const emit = defineEmits(['update:modelValue']);

onMounted(() => {
  model.value = props?.modelValue
});

const model = ref(null);

const props = defineProps({
  modelValue: {
    type: undefined,
    default: false,
  },
  color: {
    type: String,
    default: 'primary'
  },
  label: {
    type: String,
    default: ''
  },
  error: {
    type: Boolean,
    default: false,
  },
  disabled: {
    type: Boolean,
    default: false,
  },
  indeterminate: {
    type: Boolean,
    default: false,
  },
  rules: {
    type: Array,
    default: () => [],
  }
})

const update = () => {
  emit('update:modelValue', model?.value)
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue;
  }
})
</script>

<style scoped>
</style>
